SmartRepair = LibStub("AceAddon-3.0"):NewAddon("SmartRepair", "AceConsole-3.0", "AceEvent-3.0")

local SMART_REPAIR_VERSION = GetAddOnMetadata('SmartRepair', 'Version')

repairchoices = {
	[1] = "Self Repair",
	[2] = "Guild Repair",
	[3] = "No Action",
}

local options = {
	name = "Smart Repair  v" .. SMART_REPAIR_VERSION,
	handler = SmartRepair,
	type = 'group',
	args = {
		description = {
			name = "Smart Repair allows you to set up how you want to repair your gear based on different conditions.  Depending on your current group status, you can set up a priority queue for how you want to repair your armor.",
			order = 1,
			type = "description",
			width = "full",
		},
		messages = {
			type = "toggle",
			name = "Messages",
			desc = "Enable or disable messages from Smart Repair in your chat window.",
			order = 2,
			get = "MessagesGet",
			set = "MessagesSet",
		},
		header1 = {
			name = "When Solo...",
			type = "header",
			order = 10,
		},
		header1_choice1 = {
			name = "First:",
			type = "select",
			desc = "This will be the first attempted action when you are solo.",
			values = repairchoices,
			get = "Header1_Choice1_Get",
			set = "Header1_Choice1_Set",
			style = "dropdown",
			order = 11,
		},
		header1_choice2 = {
			name = "Second:",
			type = "select",
			desc = "This will be the second attempted action when you are solo.",
			values = repairchoices,
			get = "Header1_Choice2_Get",
			set = "Header1_Choice2_Set",
			style = "dropdown",
			order = 12,
			disabled = "SoloChoice1",
		},
		header1_choice3 = {
			name = "Third:",
			type = "select",
			desc = "This will be the third attempted action when you are solo.",
			values = repairchoices,
			get = "Header1_Choice3_Get",
			set = "Header1_Choice3_Set",
			style = "dropdown",
			order = 13,
			disabled = "SoloChoice2",
		},
		space1 = {
			name = "",
			type = "description",
			order = 14,
			width = "full",
		},
		header2 = {
			name = "When In a 5 Man Group...",
			type = "header",
			order = 20,
		},
		header2_choice1 = {
			name = "First:",
			type = "select",
			desc = "This will be the first attempted action when you are in a party.",
			values = repairchoices,
			get = "Header2_Choice1_Get",
			set = "Header2_Choice1_Set",
			style = "dropdown",
			order = 21,
		},
		header2_choice2 = {
			name = "Second:",
			type = "select",
			desc = "This will be the second attempted action when you are in a party.",
			values = repairchoices,
			get = "Header2_Choice2_Get",
			set = "Header2_Choice2_Set",
			style = "dropdown",
			order = 22,
			disabled = "PartyChoice1",
		},
		header2_choice3 = {
			name = "Third:",
			type = "select",
			desc = "This will be the third attempted action when you are in a party.",
			values = repairchoices,
			get = "Header2_Choice3_Get",
			set = "Header2_Choice3_Set",
			style = "dropdown",
			order = 23,
			disabled = "PartyChoice2",
		},
		space2 = {
			name = "",
			type = "description",
			order = 24,
			width = "full",
		},
		header3 = {
			name = "When In a Guild 5 Man Group...",
			type = "header",
			order = 30,
		},
		header3_choice1 = {
			name = "First:",
			type = "select",
			desc = "This will be the first attempted action when you are in a guild party.",
			values = repairchoices,
			get = "Header3_Choice1_Get",
			set = "Header3_Choice1_Set",
			style = "dropdown",
			order = 31,
		},
		header3_choice2 = {
			name = "Second:",
			type = "select",
			desc = "This will be the second attempted action when you are in a guild party.",
			values = repairchoices,
			get = "Header3_Choice2_Get",
			set = "Header3_Choice2_Set",
			style = "dropdown",
			order = 32,
			disabled = "PartyGuildChoice1",
		},
		header3_choice3 = {
			name = "Third:",
			type = "select",
			desc = "This will be the third attempted action when you are in a guild party.",
			values = repairchoices,
			get = "Header3_Choice3_Get",
			set = "Header3_Choice3_Set",
			style = "dropdown",
			order = 33,
			disabled = "PartyGuildChoice2",
		},
		space3 = {
			name = "",
			type = "description",
			order = 34,
			width = "full",
		},
		header4 = {
			name = "When In a Raid Group...",
			type = "header",
			order = 40,
		},
		header4_choice1 = {
			name = "First:",
			type = "select",
			desc = "This will be the first attempted action when you are in a raid.",
			values = repairchoices,
			get = "Header4_Choice1_Get",
			set = "Header4_Choice1_Set",
			style = "dropdown",
			order = 41,
		},
		header4_choice2 = {
			name = "Second:",
			type = "select",
			desc = "This will be the second attempted action when you are in a raid.",
			values = repairchoices,
			get = "Header4_Choice2_Get",
			set = "Header4_Choice2_Set",
			style = "dropdown",
			order = 42,
			disabled = "RaidChoice1",
		},
		header4_choice3 = {
			name = "Third:",
			type = "select",
			desc = "This will be the third attempted action when you are in a raid.",
			values = repairchoices,
			get = "Header4_Choice3_Get",
			set = "Header4_Choice3_Set",
			style = "dropdown",
			order = 43,
			disabled = "RaidChoice2",
		},
		space4 = {
			name = "",
			type = "description",
			order = 44,
			width = "full",
		},
		header5 = {
			name = "When In a Guild Raid Group...",
			type = "header",
			order = 50,
		},
		header5_choice1 = {
			name = "First:",
			type = "select",
			desc = "This will be the first attempted action when you are in a guild raid.",
			values = repairchoices,
			get = "Header5_Choice1_Get",
			set = "Header5_Choice1_Set",
			style = "dropdown",
			order = 51,
		},
		header5_choice2 = {
			name = "Second:",
			type = "select",
			desc = "This will be the second attempted action when you are in a guild raid.",
			values = repairchoices,
			get = "Header5_Choice2_Get",
			set = "Header5_Choice2_Set",
			style = "dropdown",
			order = 52,
			disabled = "RaidGuildChoice1",
		},
		header5_choice3 = {
			name = "Third:",
			type = "select",
			desc = "This will be the third attempted action when you are in a gild raid.",
			values = repairchoices,
			get = "Header5_Choice3_Get",
			set = "Header5_Choice3_Set",
			style = "dropdown",
			order = 53,
			disabled = "RaidGuildChoice2",
		},
	},
}

function SmartRepair:MessagesGet(info)
	return self.db.profile.messages
end

function SmartRepair:MessagesSet(info, value)
	self.db.profile.messages = not self.db.profile.messages
end

function SmartRepair:Header1_Choice1_Get(info)
	return self.db.profile.solo[1]
end

function SmartRepair:Header1_Choice1_Set(info, value)
	self.db.profile.solo[1] = value
end

function SmartRepair:Header1_Choice2_Get(info)
	return self.db.profile.solo[2]
end

function SmartRepair:Header1_Choice2_Set(info, value)
	self.db.profile.solo[2] = value
end

function SmartRepair:Header1_Choice3_Get(info)
	return self.db.profile.solo[3]
end

function SmartRepair:Header1_Choice3_Set(info, value)
	self.db.profile.solo[3] = value
end

function SmartRepair:SoloChoice1()
	if self.db.profile.solo[1] == 1 or self.db.profile.solo[1] == 2 then
		return false
	else
		return true
	end
end

function SmartRepair:SoloChoice2()
	if (self.db.profile.solo[2] == 1 or self.db.profile.solo[2] == 2) and self.db.profile.solo[1] ~= 3 then
		return false
	else
		return true
	end
end

function SmartRepair:Header2_Choice1_Get(info)
	return self.db.profile.party[1]
end

function SmartRepair:Header2_Choice1_Set(info, value)
	self.db.profile.party[1] = value
end

function SmartRepair:Header2_Choice2_Get(info)
	return self.db.profile.party[2]
end

function SmartRepair:Header2_Choice2_Set(info, value)
	self.db.profile.party[2] = value
end

function SmartRepair:Header2_Choice3_Get(info)
	return self.db.profile.party[3]
end

function SmartRepair:Header2_Choice3_Set(info, value)
	self.db.profile.party[3] = value
end

function SmartRepair:PartyChoice1()
	if self.db.profile.party[1] == 1 or self.db.profile.party[1] == 2 then
		return false
	else
		return true
	end
end

function SmartRepair:PartyChoice2()
	if (self.db.profile.party[2] == 1 or self.db.profile.party[2] == 2) and self.db.profile.party[1] ~= 3 then
		return false
	else
		return true
	end
end

function SmartRepair:Header3_Choice1_Get(info)
	return self.db.profile.partyguild[1]
end

function SmartRepair:Header3_Choice1_Set(info, value)
	self.db.profile.partyguild[1] = value
end

function SmartRepair:Header3_Choice2_Get(info)
	return self.db.profile.partyguild[2]
end

function SmartRepair:Header3_Choice2_Set(info, value)
	self.db.profile.partyguild[2] = value
end

function SmartRepair:Header3_Choice3_Get(info)
	return self.db.profile.partyguild[3]
end

function SmartRepair:Header3_Choice3_Set(info, value)
	self.db.profile.partyguild[3] = value
end

function SmartRepair:PartyGuildChoice1()
	if self.db.profile.partyguild[1] == 1 or self.db.profile.partyguild[1] == 2 then
		return false
	else
		return true
	end
end

function SmartRepair:PartyGuildChoice2()
	if (self.db.profile.partyguild[2] == 1 or self.db.profile.partyguild[2] == 2) and self.db.profile.partyguild[1] ~= 3 then
		return false
	else
		return true
	end
end

function SmartRepair:Header4_Choice1_Get(info)
	return self.db.profile.raid[1]
end

function SmartRepair:Header4_Choice1_Set(info, value)
	self.db.profile.raid[1] = value
end

function SmartRepair:Header4_Choice2_Get(info)
	return self.db.profile.raid[2]
end

function SmartRepair:Header4_Choice2_Set(info, value)
	self.db.profile.raid[2] = value
end

function SmartRepair:Header4_Choice3_Get(info)
	return self.db.profile.raid[3]
end

function SmartRepair:Header4_Choice3_Set(info, value)
	self.db.profile.raid[3] = value
end

function SmartRepair:RaidChoice1()
	if self.db.profile.raid[1] == 1 or self.db.profile.raid[1] == 2 then
		return false
	else
		return true
	end
end

function SmartRepair:RaidChoice2()
	if (self.db.profile.raid[2] == 1 or self.db.profile.raid[2] == 2) and self.db.profile.raid[1] ~= 3 then
		return false
	else
		return true
	end
end

function SmartRepair:Header5_Choice1_Get(info)
	return self.db.profile.raidguild[1]
end

function SmartRepair:Header5_Choice1_Set(info, value)
	self.db.profile.raidguild[1] = value
end

function SmartRepair:Header5_Choice2_Get(info)
	return self.db.profile.raidguild[2]
end

function SmartRepair:Header5_Choice2_Set(info, value)
	self.db.profile.raidguild[2] = value
end

function SmartRepair:Header5_Choice3_Get(info)
	return self.db.profile.raidguild[3]
end

function SmartRepair:Header5_Choice3_Set(info, value)
	self.db.profile.raidguild[3] = value
end

function SmartRepair:RaidGuildChoice1()
	if self.db.profile.raidguild[1] == 1 or self.db.profile.raidguild[1] == 2 then
		return false
	else
		return true
	end
end

function SmartRepair:RaidGuildChoice2()
	if (self.db.profile.raidguild[2] == 1 or self.db.profile.raidguild[2] == 2) and self.db.profile.raidguild[1] ~= 3 then
		return false
	else
		return true
	end
end

local defaults = {
	profile = {
		solo = {
			[1] = repairchoices[3],
			[2] = repairchoices[3],
			[3] = repairchoices[3],
		},
		party = {
			[1] = repairchoices[3],
			[2] = repairchoices[3],
			[3] = repairchoices[3],
		},
		partyguild = {
			[1] = repairchoices[3],
			[2] = repairchoices[3],
			[3] = repairchoices[3],
		},
		raid = {
			[1] = repairchoices[3],
			[2] = repairchoices[3],
			[3] = repairchoices[3],
		},
		raidguild = {
			[1] = repairchoices[3],
			[2] = repairchoices[3],
			[3] = repairchoices[3],
		},
		messages = true,
	},
}

function SmartRepair:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SmartRepairDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SmartRepair", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SmartRepair", "Smart Repair")
	self:RegisterChatCommand("smartrepair", "ChatCommand")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SmartRepair-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SmartRepair-Profiles", "Profiles", "Smart Repair")
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
end

function SmartRepair:RefreshConfig()
	self.db.profile = self.db.profile
end

function SmartRepair:ChatCommand()
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end

function SmartRepair:GetGroupStatus()
	local inGuildGroup = InGuildParty()
	if GetRealNumPartyMembers() == 0 and GetRealNumRaidMembers() == 0 then --solo
		return "solo"
	elseif GetRealNumPartyMembers() > 0 and GetRealNumRaidMembers() == 0 and not inGuildGroup then --5 man non-guild group
		return "party"
	elseif GetRealNumPartyMembers() > 0 and GetRealNumRaidMembers() == 0 and inGuildGroup then --5 man guild group
		return "partyguild"
	elseif GetRealNumRaidMembers() > 0 and not inGuildGroup then --raid group
		return "raid"
	elseif GetRealNumRaidMembers() > 0 and inGuildGroup then --guild raid group
		return "raidguild"
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r ERROR occurred determining your group status!")
	end
end

function SmartRepair:MERCHANT_SHOW()
	if CanMerchantRepair() then
		local myGroupStatus = SmartRepair:GetGroupStatus()
		local repairedflag = false
		local repairAllCost, canRepair = GetRepairAllCost()
		local _, _, guildRankIndex = GetGuildInfo("player")
		local guildMoney = GetGuildBankWithdrawMoney()
		if guildMoney == -1 then
			guildMoney = GetGuildBankMoney()
		end
		if myGroupStatus ~= nil then
			for i = 1, 3, 1 do
				if self.db.profile[myGroupStatus][i] == 1 and not repairedflag then --repair using own money
					if canRepair and repairAllCost > GetMoney() then
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r Insufficient personal funds to repair!") end
					elseif canRepair then
						repairedflag = true
						RepairAllItems()
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage(("|cFFe08800Smart Repair:|r Used personal funds to repair for %d|cFFffd700g|r %d|cFFc7c7cfs|r %d|cFFeda55fc|r."):format(repairAllCost / 100 / 100, (repairAllCost / 100) % 100, repairAllCost % 100)) end
					--else
						--repairedflag = true
					end
				elseif self.db.profile[myGroupStatus][i] == 2 and not repairedflag then --repair using guild money
					if canRepair and not IsInGuild() then
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r Can't use guild funds to repair.  You are not in a guild!") end
					elseif canRepair and CanGuildBankRepair() == false then
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r Insufficient permission to use guild funds for repairs!") end
					elseif canRepair and repairAllCost > guildMoney then
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r Insufficient guild funds to repair!") end
					elseif canRepair and CanGuildBankRepair() then
						repairedflag = true
						RepairAllItems(1)
						if self.db.profile.messages then DEFAULT_CHAT_FRAME:AddMessage(("|cFFE08800Smart Repair:|r Used guild funds to repair for %d|cFFffd700g|r %d|cFFc7c7cfs|r %d|cFFeda55fc|r."):format(repairAllCost / 100 / 100, (repairAllCost / 100) % 100, repairAllCost % 100)) end
					--else
						--repairedflag = true
					end
				end
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Smart Repair:|r Unable to determine your group status!")
		end
	end
end

function SmartRepair:OnEnable()
	SmartRepair:RegisterEvent("MERCHANT_SHOW")
end

function SmartRepair:OnDisable()
	SmartRepair:UnregisterEvent("MERCHANT_SHOW")
end